
;Error[121]   C:\_MPLAB8\_MESPROJETS_ASM\_12F1840_LCD_2WIRES\12F1840_LCD_2WIRES.ASM 76 : Illegal label (#IFDEF Affiche)
; config vue par Pickit2  09C4 3603
; NOTA: deconnecter potar sur RA0 (=ICSP pin !) si probleme pour charger le HEX
; ou metre le potar de test  50%

;you can have a look on this 2 wires LCD interface in ASM use a 74HTC164 + classic LCD
;2-wire-lcd-74ls164-1b.jpg
;
;
;Hd44780 display commands:
; 0x0f = initiate display cursor on blinking
; 0x0c = initiate display cursor off
; 0x01 = clear display fills display with spaces (0x20).
; 0x02 = HOME returns to line one first character
; 0x38 = 2 lines X 16 char 8 bits mode. Defaults to 1 line mode.
; 0x10 = cursor left
; 0x14 = cursor right
; 0x18 = Shifts entire display left
; 0x1c = Shifts entire display right 
;Command(0x80); // begin on 1st line
;Command(0x80 + 0x40); // begin on 2nd line 


    List        P=12F1840     ; List directive to define processor, to adapt to your Processor
    #Include    <p12f1840.inc>    ;to adapt to your Processor specific variable definitions
; mettre en commantaire les 2 lignes ci dessous pour NE PAS AFFICHER la valeur 0123456789* et la valeur ANA sur le LCD 
#define Affiche
; Mettre en commentaire la ligne ci dessous si les gros delay ne sont pas utilises
;#define BigTempo


;   Address    Value   Field                 Category                                                    Setting                                     
;
;    8007      09C4  FOSC    Oscillator Selection                   INTOSC oscillator: I/O function on CLKIN         
;                    WDTE    Watchdog Timer Enable                  WDT disabled                                                 
;                    PWRTE   Power-up Timer Enable                  PWRT enabled                                                 
;                    MCLRE   MCLR Pin Function Select               MCLR/VPP pin function is MCLR        
;                    CP      Flash Program Memory Code Protection   Program memory code protection is disabled;
;					CPD		Data Memory Code Protection            Data memory code protection is disabled                     
;                    BOREN   Brown-out Reset Enable                 Brown-out Reset disabled      
;					CLKOUTEN	Clck Out Enable                   CLKOUT function is disabled. I/O or oscillator function on the CLKOUT pin        
;                   IESO    Internal/External Switchover           Internal/External Switchover mode is disable
;                   FCMEN   Fail-Safe Clck Monitor Enable         Fail-Safe Clck Monitor is disabled
;   8008      3EFF  WRT     Flash Memory Self-Write Protection     Write protection off
;                   PLLEN   PLL Enable                             4x PLL disabled 
; 				   STVREN  Stack Overflow/Underflow Reset Enable  Stack Overflow or Underflow will cause a Reset
;                   BORV    Brown-out Reset Voltage Selection      Brown-out Reset Voltage (Vbor), low trip point selected.;
;	               LVP     Low-Voltage Programming Enable         Low-voltage programming enabled  



#Define Donnee  LATA,1
#Define Clck LATA,2

    ; Macros
ClckStrobe MACRO       ; Strobe the Data Bit
    bsf Clck
	NOP
    bcf Clck
    ENDM

EStrobe MACRO           ; Strobe the "E" Bit
    bsf Donnee
	NOP
    bcf Donnee
    ENDM


  	Cblock      0x020    ; to adapt for PIC10F200  ie : 0x010
	Dlay                ; 8 Bit Delay Variable
	Temp                ; Temporary Value Used When Sending Out Data
	NOTemp            ; Temporary Value to "NybbleOutput"
	Result			; ADC 8 bits mesure 
	btmp; affichage octet --> decimal 3 digits ( de 0 a 255 )-> LCD

	DIVIS	; diviseur
	DIVID  ;
	QUOT  	;quotient
	REMAIN  ; reste

;#ifdef Affiche     ; error 102 ???? si declar ainsi !!
	bcent;
	bdix;
	bun;
;#endif

;#ifdef BigTempo
	count1;
	count2;
	count3;
;#endif
    count
    endc


    ORG 0x00        ; Processor Reset Vector
    goto    START       ; Go to beginning of program

    ORG 0x04        ; Interrupt Vector Location
	NOP
	NOP


START
    CLRF    PORTA       ; PortA all low
;    CLRF    PORTB       ; PortB all low  NO port B on this 8pin MCU
;    BSF STATUS,RP0  ; Bank 1   .... gestion bank differente sur 12F1840
    MOVLB 1;
    MOVLW   b'01011010' ; Make clock 1Mhz  IRCF<3:0>: Internal Oscillator Frequency Select bits
;1111 = 16 MHz HF
;1101 = 4MHz HF
;1011 = 1MHz HF
	BANKSEL OSCCON; Bank 1
	MOVWF   OSCCON   ;  
	BANKSEL TRISA
    MOVLW   b'00101001' ; Bit 0, 3  as input
    MOVWF   TRISA       ; PortA all output except MCLR and RA0 analog

	BANKSEL ADCON1 ;
	MOVLW  b'01110000' ;Left justify  Frc
	;clock
	MOVWF ADCON1 ;Vdd and Vss Vref
	BANKSEL ANSELA ;      erreur LABEL sur exemple datasheet !
	BSF ANSELA,0 ;Set RA0 to analog
	BANKSEL ADCON0 ;
	MOVLW  b'00000001' ;Select channel AN0
	MOVWF ADCON0 ;Turn ADC On
    call    Dlay160     ; Wait 160 usecs before Sending the Third Time
	BSF ADCON0,ADGO ;Start conversion
    NOP
	BTFSC ADCON0,ADGO ;Is conversion done?
	GOTO $-1 ;No, test again
	BANKSEL ADRESH ;
	MOVF ADRESH,W ;Read MSB 
	BANKSEL Result
	MOVWF Result ;store it
    

; ===== Initialize LCD =====
   
#ifdef BigTempo
    call delay_250ms
#else
	call    Dlay5
	call    Dlay5
	call    Dlay5
	call    Dlay5
#endif
 
    bcf STATUS, C   ; Clear Carry (Instruction Out)
    movlw   0x03        ; Reset Command
    call    NybbleOut   ; Send the Nybble
    call    Dlay5       ; Wait 5 msecs before Sending Again
    EStrobe
    call    Dlay160     ; Wait 160 usecs before Sending the Third Time
    EStrobe
    call    Dlay160     ; Wait 160 usecs before Sending the Third Time
    bcf STATUS, C
    movlw   0x02        ; Set 4 Bit Mode
    call    NybbleOut
    call    Dlay160
    movlw   0x28        ; Note that it is a 2 Line Display
    call    SendINS
    movlw   0x08        ; Turn off the Display
    call    SendINS
    movlw   0x01        ; Turn off the Display
    call    SendINS
    movlw   0x06        ; Turn off the Display
    call    SendINS

Loop      ; ---------- Loop Forever when Done-------------------------
    movlw   0x01        ; Clear the Display RAM
    call    SendINS
    call    Dlay5       ; Note, Can take up to 4.1 msecs
    movlw   0x06        ; Enable Cursor Move Direction
    call    SendINS
    movlw   0x0C        ; Turn the LCD Back On
    call    SendINS
	call    Dlay5 

#ifdef Affiche
; affiche de 0  9
   movlw '0'
   call    SendCHAR  
   movlw '1'
   call    SendCHAR  
   movlw '2'
   call    SendCHAR  
    movlw '3'
   call    SendCHAR  
   movlw '4'
   call    SendCHAR  
   movlw '5'
   call    SendCHAR  
   movlw '6'
   call    SendCHAR  
   movlw '7'
   call    SendCHAR 
   movlw '8'
   call    SendCHAR 
   movlw '9'
   call    SendCHAR  
#endif
 
   ;movlb 1  ; acces bank1 
   BANKSEL ADCON0
   BSF ADCON0,ADGO ;Start conversion
   NOP
   BTFSC ADCON0,ADGO ;Is conversion done?
   BRA $-1 ;No, test again
   MOVF ADRESH,W ;Read MSB 
   MOVLB 0		; acces to bank 0
   MOVWF Result ;store it
   MOVWF btmp 
   MOVWF DIVID
 
#ifdef Affiche
   movlw   0xC0        ; 2nd line of LCD 
   call    SendINS
   movf Result,W
   call  bcd ; affichage valeur de ADC 8 bits 
   movlw '*' ; separateur
   call    SendCHAR
#endif

   movlw .28   ; 255/28=9
   movwf DIVIS

divide          clrf    QUOT                   ;Clear quotient
                clrf    REMAIN                    ;Clear remainder
                movlw   0x08                   ;Bit count
                movwf   count
loopd           rlf     DIVID,F                ;Shift dividend bit
                rlf     REMAIN,F                  ;into remainder
                movf    DIVIS,W                ;Trial subtraction
                subwf   REMAIN,W
                skpnc
                movwf   REMAIN                    ;Subtraction was ok
                rlf     QUOT,F                 ;Carry is result bit
                decfsz  count,F                ;Next bit
                goto    loopd

   MOVF QUOT,W
   ADDLW '0'    ;   valeur en beaufort
   call    SendCHAR 
 
#ifdef BigTempo
    call delay_1sec
#else
	call    Dlay5
	call    Dlay5
	call    Dlay5
	call    Dlay5
#endif

   goto        Loop


; ===== Subroutines =====

SendCHAR            ; Send the Character to the LCD
    movwf   Temp        ; Save the Temporary Value
    swapf   Temp, w     ; Send the High Nybble
    bsf STATUS, C   ; RS = 1
    call    NybbleOut
    movf    Temp, w     ; Send the Low Nybble
    bsf STATUS, C
    call    NybbleOut
    return

SendINS             ; Send the Instruction to the LCD
    movwf   Temp        ; Save the Temporary Value
    swapf   Temp, w     ; Send the High Nybble
    bcf STATUS, C   ; RS = 0
    call    NybbleOut
    movf    Temp, w     ; Send the Low Nybble
    bcf STATUS, C
    call    NybbleOut
    return

NybbleOut           ; Send a Nybble to the LCD
    movwf   NOTemp      ; Save the Nybble to Shift Out
    swapf   NOTemp,F      ; Setup to Output to the High Part of the Byte
    movlw   6       ; Clear the Shift Register
    movwf   Dlay

NO2Loop1
    ClckStrobe
    decfsz  Dlay,F
    goto    NO2Loop1
    movlw   5       ; #### - Now, Shift out the Data with the "RS" Bit
    movwf   Dlay
    bsf Donnee        ; Put out the Gate Bit
    ClckStrobe

NO2Loop2
    bcf Donnee        ; #### - Clear the Data Bit (which is the Clck)
    btfsc   STATUS, C   ; #### - If the Bit to be output is a "1", Shift it Out
    bsf Donnee
    ClckStrobe
    rlf NOTemp,F      ; #### - Shift the Next Bit into the Carry Flag
    decfsz  Dlay,F
    goto    NO2Loop2
    EStrobe         ; Strobe out the LCD Data
    return

Dlay160             ; Delay 160 usecs
    movlw   40     ; Loop Until Carry Set
    addlw   1
    btfss   STATUS, C
    goto    $-2
    return

Dlay5               ; Delay 5 msecs
    movlw   64       ; Set up the Delay
    movwf   Dlay
    movlw   24
    addlw   1
    btfsc   STATUS, Z
    decfsz  Dlay,F
    goto   $-3
    return

#ifdef BigTempo
delay_250ms
    movlw   .2         
    movwf   count1 
	goto del1

delay_1sec
    movlw   .8          
    movwf   count1 
del1
  	movlw   .232           
    movwf   count2  
  	movlw   .235           
    movwf   count3  
delay2       
	decfsz  count3,f      ;2 + 5*(count3-1) +
    goto    $-1        ;2 + (5*255 +2+5) * (count2-1) +
    decfsz  count2,f   ;2 + (5*255*256 +2 + 5*255 +2+5) *(count1-1)
    goto    $-3        ;  =
    decfsz  count1,f  ;5(count3-1)+1282(count2-1)+327684(count1-1)+6  
    goto    $-5       
    return   
#endif

#ifdef Affiche
bcd
		movwf  btmp		; affichage octet --> decimal 3 digits ( de 0 a 255 )-> RS232
		movlw  '0'
		movwf  bcent
		movwf  bdix
bcd1    movlw  .100
		subwf  btmp,w
		bnc    bcd2
		movwf  btmp
		incf   bcent,f
		goto   bcd1
bcd2  movlw  .10
		subwf  btmp,w
		bnc bcd3
		movwf btmp
		incf   bdix,f
		goto   bcd2
bcd3	movlw  '0'
		addwf  btmp,w
		movwf  bun
		movf   bcent,w
 	  call    SendCHAR  
		movf   bdix,w
	  call    SendCHAR  
		movf   bun,w
	  call    SendCHAR  
		return
#endif

 end
----------------------------------------------------------------------
Release build of project `C:\_Mplab8\_Mesprojets_ASM\_12F1840_LCD_2wires\12F1840_LCD_2w.mcp' started.
Language tool versions: MPASMWIN.exe v5.51, mplink.exe v4.49, mplib.exe v4.49
Sun Jun 21 19:46:58 2015
----------------------------------------------------------------------
Clean: Deleting intermediary and output files.
Clean: Deleted file "C:\_Mplab8\_Mesprojets_ASM\_12F1840_LCD_2wires\12F1840_LCD_2wires.o".
Clean: Deleted file "C:\_Mplab8\_Mesprojets_ASM\_12F1840_LCD_2wires\12F1840_LCD_2wires.err".
Clean: Deleted file "C:\_Mplab8\_Mesprojets_ASM\_12F1840_LCD_2wires\12F1840_LCD_2wires.hex".
Clean: Deleted file "C:\_Mplab8\_Mesprojets_ASM\_12F1840_LCD_2wires\12F1840_LCD_2wires.lst".
Clean: Deleted file "C:\_Mplab8\_Mesprojets_ASM\_12F1840_LCD_2wires\12F1840_LCD_2wires.cof".
Clean: Done.
Executing: "C:\Program Files (x86)\Microchip\MPASM Suite\MPASMWIN.exe" /q /p12F1840 "12F1840_LCD_2wires.asm" /l"12F1840_LCD_2wires.lst" /e"12F1840_LCD_2wires.err"
Message[302] C:\_MPLAB8\_MESPROJETS_ASM\_12F1840_LCD_2WIRES\12F1840_LCD_2WIRES.ASM 69 : Register in operand not in bank 0.  Ensure that bank bits are correct.
Message[302] C:\_MPLAB8\_MESPROJETS_ASM\_12F1840_LCD_2WIRES\12F1840_LCD_2WIRES.ASM 71 : Register in operand not in bank 0.  Ensure that bank bits are correct.
Message[302] C:\_MPLAB8\_MESPROJETS_ASM\_12F1840_LCD_2WIRES\12F1840_LCD_2WIRES.ASM 80 : Register in operand not in bank 0.  Ensure that bank bits are correct.
Message[302] C:\_MPLAB8\_MESPROJETS_ASM\_12F1840_LCD_2WIRES\12F1840_LCD_2WIRES.ASM 82 : Register in operand not in bank 0.  Ensure that bank bits are correct.
Message[302] C:\_MPLAB8\_MESPROJETS_ASM\_12F1840_LCD_2WIRES\12F1840_LCD_2WIRES.ASM 85 : Register in operand not in bank 0.  Ensure that bank bits are correct.
Message[302] C:\_MPLAB8\_MESPROJETS_ASM\_12F1840_LCD_2WIRES\12F1840_LCD_2WIRES.ASM 87 : Register in operand not in bank 0.  Ensure that bank bits are correct.
Message[302] C:\_MPLAB8\_MESPROJETS_ASM\_12F1840_LCD_2WIRES\12F1840_LCD_2WIRES.ASM 88 : Register in operand not in bank 0.  Ensure that bank bits are correct.
Message[302] C:\_MPLAB8\_MESPROJETS_ASM\_12F1840_LCD_2WIRES\12F1840_LCD_2WIRES.ASM 91 : Register in operand not in bank 0.  Ensure that bank bits are correct.
Warning[202] C:\_MPLAB8\_MESPROJETS_ASM\_12F1840_LCD_2WIRES\12F1840_LCD_2WIRES.ASM 198 : Argument out of range.  Least significant bits used.
Executing: "C:\Program Files (x86)\Microchip\MPASM Suite\mplink.exe" /p12F1840 "12F1840_LCD_2wires.o" /z__MPLAB_BUILD=1 /o"12F1840_LCD_2wires.cof" /M"12F1840_LCD_2wires.map" /W /x
MPLINK 4.49, Linker
Device Database Version 1.14
Copyright (c) 1998-2011 Microchip Technology Inc.
Errors    : 0

Loaded C:\_Mplab8\_Mesprojets_ASM\_12F1840_LCD_2wires\12F1840_LCD_2wires.cof.
----------------------------------------------------------------------
Release build of project `C:\_Mplab8\_Mesprojets_ASM\_12F1840_LCD_2wires\12F1840_LCD_2w.mcp' succeeded.
Language tool versions: MPASMWIN.exe v5.51, mplink.exe v4.49, mplib.exe v4.49
Sun Jun 21 19:46:59 2015
----------------------------------------------------------------------
BUILD SUCCEEDED
